#include <stdio.h>
#include <stdlib.h> /* Imprescindible para utilizar strtof */
#include <math.h> /* Imprescindible - contiene sqrt() */

float a, /* coeficiente de x^2 */
b, /* coeficiente de x */
c, /* término independiente */
d; /* discriminante */

float r1,r2, /* raíces reales y distintas */
preal, pimaginaria, /* Raíces complejas conjugadas */
rrd; /* Raíz real doble */

int main(int argc, char * argv[])
{

  printf("Resolución de ecuaciones de segundo grado, ax^2 + bx + c = 0.\n\n");
  
  if (4 != argc)
    {
      printf("\n\nUtilización: ./resuelve a b c\n\n");
      return 0;
    }
  a = strtof(argv[1], NULL);
  b = strtof(argv[2], NULL);
  c = strtof(argv[3], NULL);
  printf("\nLa ecuación es %fx^2",a);
  b > 0.0 ? printf(" +") : printf(" ");
  printf("%fx",b);
  c > 0.0 ? printf(" +") : printf(" ");
  printf("%f = 0.", c);
  printf("\n\nSolución");
  d = b*b -4.0*a*c;
  if (d > 0.0) /* discriminante positivo, raíces reales y distintas */
    {
      r1 = (-b + sqrt(d))/(2.0*a);
      r2 = (-b - sqrt(d))/(2.0*a);
      printf("\n\nRaíces reales y distintas: r1 = %f, r2 = %f", r1, r2);
    }
  else
    {
      if (d < 0.0) /* discriminante negativo, raíces complejas conjugadas */
        {
          preal = (-b)/(2.0*a);
          pimaginaria = sqrt(-d)/(2.0*a);
          printf( "\n\nRaíces complejas conjugadas: %f+j%f, %f-j%f",
          preal, pimaginaria, preal, pimaginaria);
        }
      else
        {
          rrd = (-b)/(2.0*a);
          printf("\n\nUna raíz real doble: rrd = %f", rrd);
        }
    }
  puts("\n\nTerminación normal del programa.\n");
  return 0;
}