#include <stdio.h>
/*
 Construir un programa que admita una matriz 3x3 y un vector de ℜ³ y calcula
 el producto de la matriz por el vector. Sugerencia:
 si se llama f a la aplicación definida por la matriz, utilizar un vector de Ker(f)
 para comprobar que en efecto el resultado de aplicar la matriz al vector es el vector 0.
 */

typedef float vector_3x1[3][1];
typedef float matriz_3x3[3][3];

/*
 Recuérdese q MxN x NxP = MxP
 
 En este no hay problema, son matrices cuadradas de dimensión N
 y el vector es de también de dimensión N ( = 3).
 
 Recuérdese también la expresión:
 
        N
       ---
       \
 w  =   >   a   * v
  i    /     ij    j
       ---
	j = 1
*/


int main (int argc, const char * argv[]) {
    
	matriz_3x3 A;
	vector_3x1 v;
	vector_3x1 w;
	int i,j;
	printf("\n\nProducto de una matriz por un vector.\n\n");
	/*
	 Lectura de datos - matriz
	 */
	printf("Escriba los coeficientes de la matriz:\n\n");
	for (i=0; i<3; i++) {
		for (j=0; j<3; j++) {
			printf("A[%d][%d] = ? ", i, j);
			scanf("%f%*c",&A[i][j]);
		}
	}
	printf("\n\nLa matriz considerada es:\n\n");
	for (i=0; i<3; i++) {
		printf("| ");
		for (j=0; j<3; j++) {
			printf("%6.2f ",A[i][j]);
		}
		printf("|\n");
	}
	/*
	 Lectura de datos - Vector
	 */
	printf("\n\nEscriba el vector:\n\n");
	for (i=0; i<3; i++) {
		printf("v[%d] = ? ",i);
		scanf("%f%*c",&v[i][0]);
	}
	printf("\n\nEl vector considerado es: \n\n");
	for (i=0; i<3; i++) {
		printf("| %6.2f |\n",v[i][0]);
	}
	/*
	 Cálculo A * v = w
	 */
	for (i=0; i<3; i++) {
		w[i][0] = 0.0;
		for (j=0; j<3; j++)
			w[i][0]+= A[i][j]*v[j][0];
	}
	/*
	 Impresión de resultados
	*/
	printf("\n\nEl producto de la matriz por el vector es:\n\n");
	for (i=0; i<3; i++) {
		printf("| %6.2f |\n",w[i][0]);
	}
	printf("\n\nTerminación normal del programa.\n\n");
    return 0;
}
