/*
 *  funciones.c
 *  bdd_101
 *
 *  Created by coti on 16/11/09.
 *  Copyright 2009 Tests by Coti. All rights reserved.
 *
 */

#include "funciones.h"

void listado(RegistroRef * d, int n)
{
	int i;
	char * formato = "%65s %4d %6.2f\n";
	printf("\n\nListado\n\n");
	for (i=0; i<n; i++) {
		if (d[i]->edad !=0)
			printf(formato, d[i]->nombre, d[i]->edad, d[i]->talla);
	}
	printf("\n");
}
void iniciacion(RegistroRef * d, int n)
{
	int i;
	for (i=0; i<n; i++) {
		d[i] = malloc(sizeof(Registro));
		d[i]->edad = 0;
		d[i]->talla = 0.0;
		strcpy(d[i]->nombre,"");
	}
}
void iniciacion2(RegistroRef * d, int n)
{
	int i;
	Registro cero = {"", 0, 0.0};
	for (i=0; i<n; i++) {
		d[i] = malloc(sizeof(Registro));
		*d[i] = cero;
	}
}
void altas(RegistroRef * d, int n)
{
	int num_registro_vacio = -1;
	int i;
	for (i=0; i<n; i++) {
		if (0 == d[i]->edad) {
			num_registro_vacio = i;
			break;
		}
	}
	if (-1 == num_registro_vacio) {
		printf("\n\nImposible dar alta: base de datos llena\n\n");
	}
	else {
		rellenar_registro(d[num_registro_vacio]);
	}
	
}
void bajas(RegistroRef * d, int n)
{
	int num_registro_eliminado = -1;
	listado(d,n);
	do{
		num_registro_eliminado = pedirInt("Deme el número del registro eliminado", 0, n);
	} while(0 == d[num_registro_eliminado]->edad);
	d[num_registro_eliminado]->edad = 0;
	d[num_registro_eliminado]->talla = 0.0;
	strcpy(d[num_registro_eliminado]->nombre, "");
	
}
void informes(RegistroRef * d, int n)
{
	char name[64];
	int valor_edad;
	float valor_talla;
	char c;
	int i;
	do {
		printf("\n\nInforme por (1) Nombre (2) Edad (3) Talla: [ESC] ");
		switch (c=getch()) {
			case '1':
				strcpy(name,pedir("Nombre buscado: "));
				for (i=0; i<n; i++) {
					if (strcmp(name, d[i]->nombre) == 0) {
						escribir_registro(d[i]);
					}
				}
				break;
			case '2':
				valor_edad = pedirInt("Edad buscada: ", 18, 100);
				for (i=0; i<n; i++) {
					if (valor_edad == d[i]->edad)
						escribir_registro(d[i]);
				}
				break;
			case '3':
				valor_talla = pedirFloat("Talla buscada: ", 100, 250);
				for (i=0; i<n; i++) {
					if (valor_talla == d[i]->talla) {
						escribir_registro(d[i]);
					}
				}
				break;
			case '\x1b':
				printf("\n\n");
				break;
			default:
				printf("\n\nOpción incorrecta\n\n");
				break;
		}
	} while (c!='\x1b');
}
void modificaciones2(RegistroRef * d, int n)
{
	int num_registro;
	listado(d,n);
	num_registro = pedirInt("Registro modificado: ", 0, n);
	escribir_registro(d[num_registro]);
	rellenar_registro(d[num_registro]);
}

void modificaciones(RegistroRef * d, int n)
{
	int num_registro;
	Registro temp;
	int opcion;
	listado(d,n);
	num_registro = pedirInt("Registro modificado: ", 0, n);
	escribir_registro(d[num_registro]);
	rellenar_registro(&temp);
	opcion = pedirInt("¿Desea guardar los cambios (0/1)?", 0, 1 );
	if (1 == opcion) {
		*d[num_registro] = temp;
	}// sino, no hagas nada
}

void rellenar_registro(Registro * p)
{
	printf("\n\n");
	p->edad = pedirInt("Escriba la edad: ", 18, 100);
	p->talla = pedirFloat("Escriba la talla (cm): ", 100.0, 250.0);
	do {
		strcpy(p->nombre,pedir("Escriba su nombre: "));
	} while(strlen(p->nombre) == 0);
}

void escribir_registro(Registro * p)
{
	printf("%30s %5d %6.2f\n",p->nombre, p->edad, p->talla);
}
